#pragma once
#include <QTimer>
#include "actor.h"

class TimerActor: public Actor
{
    Q_OBJECT
private:
    int timeoutMsec_;

    QTimer timer;

private slots:

    void timeout();

public slots:

    virtual void onValueChanged(uint8_t state);
    void setTimeout(const int timeoutSec);

public:
    explicit TimerActor(const int timeoutSec = 60, QObject *parent = nullptr);
    virtual QString getName();

    int getTimeout();

    virtual void store(QJsonObject& json);
    virtual void load(const QJsonObject& json);

    virtual void store(QString subsecton, QSettings* settings);
    virtual void load(QString subsecton, QSettings* settings);
};
