#include "auxitem.h"

AuxItem::AuxItem(SensorStore* sensors, Microcontroller* micro, uint32_t itemIdIn, QString name,  uint8_t value, QObject* parent): Item(sensors, itemIdIn, name, value, parent), micro_(micro)
{

}

void AuxItem::setValue(uint8_t value)
{
    Item::setValue(value);
    micro_->setAuxPwm(value);
}

void AuxItem::store(QJsonObject &json)
{
    json["Type"] = "Aux";
    Item::store(json);
}

void AuxItem::store(QString subsecton, QSettings* settings)
{
    settings->setValue(subsecton + "Type", "Aux");
    Item::store(subsecton, settings);
}
