#include "ocupancysensor.h"
#include <QTimer>
#include <QDebug>


OcupancySensorSource::OcupancySensorSource(QObject *parent): QObject (parent)
{
    connect(&ping, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(pingExit(int, QProcess::ExitStatus)));
    Timeout();
}

void OcupancySensorSource::sensorEvent(Sensor sensor)
{
    if(sensor.type == Sensor::TYPE_DOOR && sensor.id == 1 && sensor.field != 0.0f)
    {
        QTimer::singleShot(240000, this, &OcupancySensorSource::Timeout);
         qDebug()<<"starting timer";
    }
}

void OcupancySensorSource::Timeout()
{
    qDebug()<<"starting ping";
    ping.start("ping 192.168.0.104 -c 1 -W 1");
}

void OcupancySensorSource::pingExit(int exitCode, QProcess::ExitStatus exitStatus)
{
    qDebug()<<"ping finished";
    if(exitStatus == QProcess::ExitStatus::NormalExit)
    {
        qDebug()<<"Exit Code "<<exitCode;
        if(exitCode == 0)
        {
            stateChanged(Sensor(Sensor::TYPE_OCUPANCY, 0, 1, "Occupancy"));
        }
        else
        {
            stateChanged(Sensor(Sensor::TYPE_OCUPANCY, 0, 0, "Occupancy"));
        }
    }
}
