#ifndef ACTORSETTINGSDIALOG_H
#define ACTORSETTINGSDIALOG_H

#include <QDialog>
#include <QWidget>
#include "actorwidgets/alarmwidget.h"
#include "actorwidgets/sensoractorwidget.h"
#include "actorwidgets/timeractorwidget.h"
#include "actorwidgets/regulatorwdiget.h"

namespace Ui {
class ActorSettingsDialog;
}

class ActorSettingsDialog : public QDialog
{
    Q_OBJECT

private:
    Actor* actor_;
    QWidget* widget;

    void init();

public:
    ActorSettingsDialog(AlarmTime* actor, QWidget *parent = nullptr);
    ActorSettingsDialog(SensorActor* actor, SensorStore* sensors = nullptr, QWidget *parent = nullptr);
    ActorSettingsDialog(Regulator* actor, SensorStore* sensors = nullptr, QWidget *parent = nullptr);
    ActorSettingsDialog(TimerActor* actor, QWidget *parent);
    ActorSettingsDialog(Actor* actor, QWidget *parent);
    ~ActorSettingsDialog();

    void hideCancle(const bool hide);

private slots:
    void changeAction(int index);
    void valueChanged(int value);


private:
    Ui::ActorSettingsDialog *ui;
};

#endif // ACTORSETTINGSDIALOG_H
