#ifndef RELAYWIDGET_H
#define RELAYWIDGET_H

#include <QWidget>
#include <memory>
#include "itemsettingsdialog.h"
#include "../items/item.h"

namespace Ui {
class ItemWidget;
}

class ItemWidget : public QWidget
{
    Q_OBJECT
private:
    std::weak_ptr<Item> item_;

    void disable();

private slots:
    void showSettingsDialog();
    void moveToState(bool state);
    void moveToValue(int value);

public:
    explicit ItemWidget(std::weak_ptr<Item> item, bool analog = false, QWidget *parent = nullptr);
    std::weak_ptr<Item> getItem();
    bool controles(const ItemData& relay);
    ~ItemWidget();

public slots:

    void stateChanged(int state);

private:
    Ui::ItemWidget *ui;
};

#endif // RELAYWIDGET_H
